/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
	"time"
)

// checks if the SweepstakeConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SweepstakeConfiguration{}

// SweepstakeConfiguration struct for SweepstakeConfiguration
type SweepstakeConfiguration struct {
	Id string `json:"id"`
	Name string `json:"name"`
	Prizes []SweepstakePrize `json:"prizes"`
	StartAt *time.Time `json:"start_at,omitempty"`
	StartWhenRegistered *int32 `json:"start_when_registered,omitempty"`
	ContactMaxPrizes int32 `json:"contact_max_prizes"`
	Status string `json:"status"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	Type string `json:"type"`
	EventName string `json:"event_name"`
	UsageCounter int32 `json:"usage_counter"`
}

// NewSweepstakeConfiguration instantiates a new SweepstakeConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSweepstakeConfiguration(id string, name string, prizes []SweepstakePrize, contactMaxPrizes int32, status string, createdAt time.Time, updatedAt time.Time, type_ string, eventName string, usageCounter int32) *SweepstakeConfiguration {
	this := SweepstakeConfiguration{}
	this.Id = id
	this.Name = name
	this.Prizes = prizes
	this.ContactMaxPrizes = contactMaxPrizes
	this.Status = status
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.Type = type_
	this.EventName = eventName
	this.UsageCounter = usageCounter
	return &this
}

// NewSweepstakeConfigurationWithDefaults instantiates a new SweepstakeConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSweepstakeConfigurationWithDefaults() *SweepstakeConfiguration {
	this := SweepstakeConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *SweepstakeConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *SweepstakeConfiguration) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *SweepstakeConfiguration) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *SweepstakeConfiguration) SetName(v string) {
	o.Name = v
}

// GetPrizes returns the Prizes field value
func (o *SweepstakeConfiguration) GetPrizes() []SweepstakePrize {
	if o == nil {
		var ret []SweepstakePrize
		return ret
	}

	return o.Prizes
}

// GetPrizesOk returns a tuple with the Prizes field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetPrizesOk() ([]SweepstakePrize, bool) {
	if o == nil {
		return nil, false
	}
	return o.Prizes, true
}

// SetPrizes sets field value
func (o *SweepstakeConfiguration) SetPrizes(v []SweepstakePrize) {
	o.Prizes = v
}

// GetStartAt returns the StartAt field value if set, zero value otherwise.
func (o *SweepstakeConfiguration) GetStartAt() time.Time {
	if o == nil || IsNil(o.StartAt) {
		var ret time.Time
		return ret
	}
	return *o.StartAt
}

// GetStartAtOk returns a tuple with the StartAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetStartAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.StartAt) {
		return nil, false
	}
	return o.StartAt, true
}

// HasStartAt returns a boolean if a field has been set.
func (o *SweepstakeConfiguration) HasStartAt() bool {
	if o != nil && !IsNil(o.StartAt) {
		return true
	}

	return false
}

// SetStartAt gets a reference to the given time.Time and assigns it to the StartAt field.
func (o *SweepstakeConfiguration) SetStartAt(v time.Time) {
	o.StartAt = &v
}

// GetStartWhenRegistered returns the StartWhenRegistered field value if set, zero value otherwise.
func (o *SweepstakeConfiguration) GetStartWhenRegistered() int32 {
	if o == nil || IsNil(o.StartWhenRegistered) {
		var ret int32
		return ret
	}
	return *o.StartWhenRegistered
}

// GetStartWhenRegisteredOk returns a tuple with the StartWhenRegistered field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetStartWhenRegisteredOk() (*int32, bool) {
	if o == nil || IsNil(o.StartWhenRegistered) {
		return nil, false
	}
	return o.StartWhenRegistered, true
}

// HasStartWhenRegistered returns a boolean if a field has been set.
func (o *SweepstakeConfiguration) HasStartWhenRegistered() bool {
	if o != nil && !IsNil(o.StartWhenRegistered) {
		return true
	}

	return false
}

// SetStartWhenRegistered gets a reference to the given int32 and assigns it to the StartWhenRegistered field.
func (o *SweepstakeConfiguration) SetStartWhenRegistered(v int32) {
	o.StartWhenRegistered = &v
}

// GetContactMaxPrizes returns the ContactMaxPrizes field value
func (o *SweepstakeConfiguration) GetContactMaxPrizes() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ContactMaxPrizes
}

// GetContactMaxPrizesOk returns a tuple with the ContactMaxPrizes field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetContactMaxPrizesOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactMaxPrizes, true
}

// SetContactMaxPrizes sets field value
func (o *SweepstakeConfiguration) SetContactMaxPrizes(v int32) {
	o.ContactMaxPrizes = v
}

// GetStatus returns the Status field value
func (o *SweepstakeConfiguration) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *SweepstakeConfiguration) SetStatus(v string) {
	o.Status = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *SweepstakeConfiguration) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *SweepstakeConfiguration) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *SweepstakeConfiguration) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *SweepstakeConfiguration) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetType returns the Type field value
func (o *SweepstakeConfiguration) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *SweepstakeConfiguration) SetType(v string) {
	o.Type = v
}

// GetEventName returns the EventName field value
func (o *SweepstakeConfiguration) GetEventName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.EventName
}

// GetEventNameOk returns a tuple with the EventName field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetEventNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.EventName, true
}

// SetEventName sets field value
func (o *SweepstakeConfiguration) SetEventName(v string) {
	o.EventName = v
}

// GetUsageCounter returns the UsageCounter field value
func (o *SweepstakeConfiguration) GetUsageCounter() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.UsageCounter
}

// GetUsageCounterOk returns a tuple with the UsageCounter field value
// and a boolean to check if the value has been set.
func (o *SweepstakeConfiguration) GetUsageCounterOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UsageCounter, true
}

// SetUsageCounter sets field value
func (o *SweepstakeConfiguration) SetUsageCounter(v int32) {
	o.UsageCounter = v
}

func (o SweepstakeConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SweepstakeConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	toSerialize["prizes"] = o.Prizes
	if !IsNil(o.StartAt) {
		toSerialize["start_at"] = o.StartAt
	}
	if !IsNil(o.StartWhenRegistered) {
		toSerialize["start_when_registered"] = o.StartWhenRegistered
	}
	toSerialize["contact_max_prizes"] = o.ContactMaxPrizes
	toSerialize["status"] = o.Status
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	toSerialize["type"] = o.Type
	toSerialize["event_name"] = o.EventName
	toSerialize["usage_counter"] = o.UsageCounter
	return toSerialize, nil
}

type NullableSweepstakeConfiguration struct {
	value *SweepstakeConfiguration
	isSet bool
}

func (v NullableSweepstakeConfiguration) Get() *SweepstakeConfiguration {
	return v.value
}

func (v *NullableSweepstakeConfiguration) Set(val *SweepstakeConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullableSweepstakeConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullableSweepstakeConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSweepstakeConfiguration(val *SweepstakeConfiguration) *NullableSweepstakeConfiguration {
	return &NullableSweepstakeConfiguration{value: val, isSet: true}
}

func (v NullableSweepstakeConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSweepstakeConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


